#include "../common.h"
#include "defs.h"
#include <stdio.h>
#include <signal.h>
#include <errno.h>

#define	toggle(var)	var = !var

struct	sockaddr_in	locaddr;	/* our own host address */
char	buf[BUFFER];			/* general purpose character buffer */
char	convaddr[25];			/* address of our conversation in ascii */
char	host[32];				/* local host name */
char	realname[100];			/* user's real name from password file */
extern	int users;				/* number of users connected - from windows.c */
int		pending;				/* number of pending calls */
int		changed_size;			/* caught SIGWINCH, need to resize windows */

char *program;	/* fix */

main (argc, argv)
int   argc;
char *argv[];
{
	int		answer = 0;
	int		readrcok=1;
	extern	int errno;
	extern	int timer();
	extern	int quit();
	extern	int badsig();
	extern	int sigint();
	extern	int sigquit();
	extern	int sigstop();
	extern	int sigwinch();
	extern	int sigchld();
	char	*check_invite();
	char	*getdaemon();
	char	*index();
	char	*user;				/* name of user we are trying to call */
	char	*hishost = '\0';		/* and his hostname */
	char	*addr = NULL; /* fix */		/* address of conversation from getdaemon () */
	struct	sockaddr_in sin;

	extern char *version_string; /* fix */
	fd_set readfds; /* fix */

	program = *argv; /* fix */

	argv++, argc--;

	while (*argv && **argv == '-') {
		while (*++*argv) {
			switch (**argv) {
				case 'a':	if (argc > 1) {		/* given an address */
								addr = *++argv;
								argc--; 
								printf ("Using address \"%s\"\n", addr);
							}
							break;
				case 'n':	readrcok=0;
						break;
				case 'b':	toggle (Bells);		break;
				case 'd':	toggle(Debug);		break;
				case 'i':	toggle(Inverse);	break;
				case 'h':	usage();		break;
				case 'v':       printf("%s version %s\n",
						       program, version_string); /* fix */
						printf("Please send any problems, questions, or suggestions \nto odajima@mt.cs.keio.ac.jp by E-mail\n");
						       exit (0);

				case 'c':
					switch (*++*argv) {
					case 'j':
						kanji_code = K_JIS ;
						break ;
                                       case 'e':
				       case 'u':
					       kanji_code = K_EUC ;
					       break ;
                                       case 's':
					       kanji_code = K_SJIS ;
					       break ;
                                       case 'a':
					       kanji_code = -1 ;
					       break ;
                                      case 0 :
					      goto  nextarg ;
                                      }
				      break ;
			}
		}
       nextarg :
		argv++, argc--;
	}

	if (argc == 0)		/* just answer incoming calls */
		answer = 1;
	else if (argc > 2) {
		usage();
	}

	if (names ())		/* get all the various info */
		exit (1);
	if(readrcok)
		readrc ();			/* read in and act on the .phonerc */

	if (!answer) {		/* expand any user aliases and see who we're calling */
		if ((user = expalias (argv[0])) == (char *) 0)
			user = argv[0];
		if (hishost = index (user, '@'))
			*hishost++ = '\0';
		else
			hishost = host;
	}

	connected = 0;
	pending = 0;

	/*  set up all the signals  */
	signal (SIGPIPE,  SIG_IGN);
	if (!Debug) {
		signal (SIGHUP,   badsig);
		signal (SIGBUS,   badsig);
		signal (SIGSEGV,  badsig);
	}
	signal (SIGALRM,  timer);
	signal (SIGQUIT,  sigquit);
	signal (SIGINT,   sigint);
#ifdef SIGWINCH
	signal (SIGWINCH, sigwinch);
#endif 
	signal (SIGCHLD,  sigchld);

	/*  
	 *	open datagram control socket.
	 */

	if ((ctl = socket (AF_INET, SOCK_DGRAM, 0)) < 0)
		error (1, "Can't get control socket");

	sin.sin_addr.s_addr = INADDR_ANY;
	sin.sin_port = 0;
	sin.sin_family = AF_INET;

	if (bind (ctl, &sin, sizeof (sin)) < 0)
		error (1, "Can't bind control socket");

	setup ();		/* initialize all the screen stuff */

	/*  Have we been invited ???  */
	if (addr || (addr = check_invite (answer ? "*" : user, hishost))) {
		if (Debug)
			printf ("\r\nCheck_invite returned \"%s\"\r\n", addr);
		connect_daemon (addr);
		if (!connected) {
			if (Debug)
				printf ("Connection failed.\r\n");
			goto again;		/* caller has hung up !!! */
		}
	} else {
again:
		if (Debug)
			printf ("\r\nCheck_invite returned no address.\r\n");
		if (answer) {	/* don't want to place a call */
			fprintf (stderr, "\r\nNo pending calls for %s\r\n", login);
			cleanup ();
			exit (1);
		}
		do {
			putmessage ("");
			if ((addr = getdaemon()) == (char *) 0)
				error (1, "Cannot get conversation daemon address");
			if (Debug)
				printf ("\rGet_daemon returned address of \"%s\"\r\n", addr);
			connect_daemon (addr);
			if (!connected) {
				putmessage ("Trying to connect to conversation daemon.");
				printf ("Trying to connect to conversation daemon.");
				fflush (stdout);
			}
		} while (!connected);
		placecall (user, hishost, argv[1] ? argv[1] : "");
	}

	alarm (1);		/* get things rolling */

	/*
	 *  Main loop - select on sockets and handle appropriately.
	 */

	for ( ;; ) {
		extern int childpid, fromchild;
#ifdef SIGWINCH
		if (changed_size) {		/* caught SIGWINCH - have to resize windows */
			stretch (1);
			changed_size = 0;
		}
#endif
		FD_ZERO (&readfds);	/* fix */
		FD_SET (0, &readfds);	/* fix */
		FD_SET (ctl, &readfds); /* fix */
		FD_SET (stream, &readfds); /* fix */
		if (childpid)
			FD_SET (fromchild, &readfds); /* fix */
               if (select (32, &readfds, 0, 0, 0) <= 0) { /* fix */
			if (errno == EINTR)
				continue;
			error (1, "select");
		}
		errno = 0;
               if (FD_ISSET(ctl, &readfds))	/* fix */
		       readctl ();		/* fix */
               if (FD_ISSET(0, &readfds))	/* fix */
			keyboard ();		/* fix */
               if (FD_ISSET(stream, &readfds))	/* fix */
			readstream ();		/* fix */
               if (childpid && FD_ISSET(fromchild, &readfds)) /* fix */
			readchild (); 		/* fix */
	}
	/*NOTREACHED*/
}

usage()
{
	fprintf (stderr, "Usage: %s [-{bdivnc{ejsa}}] user[@host] [ tty ]\n", program); /* fixed by odajima@mt.cs.keio.ac.jp */
	exit (1);
}

