#ifndef lint
static char	rcsid[] = "$Header: tosjis.c,v 1.1 87/10/18 19:16:58 tachi Exp $" ;
#endif
/*
 * Convert EUC character to Shift JIS character
 *	given first byte in high, second in low
 *	returns Shift JIS character with first byte in high
 *	byte and second in low
 */
# define u_int	unsigned int
# define u_char	unsigned char
# define reg	register

# define FBKANJI(ch)	(((ch)>>8)&0x7f)
# define SBKANJI(ch)	((ch)&0x7f)
# define ISjlow(low)	((low >= 0x21) && (low <= 0x7e))
# define ISjhigh(high)	((high >= 0x21) && (high <= 0x7f))
# define ISoddhigh(high)	( (high) & 0x1 )
# define ISevenhigh(high)	( ! ISoddhigh(high) )
# define ISupperhigh(h)	((h >= 0x21) && (h <= 0x5e))
# define ISlowerhigh(h)	((h >= 0x5f) && (h <= 0x7f))

toSJIS(Ech)
	reg u_int	Ech;
{
	reg u_int	sJch;
	reg u_char	high, low;
	reg short	o;	/*	even flag	*/

	high = FBKANJI(Ech);
	low  = SBKANJI(Ech);
	if (!(ISjlow(low) && ISjhigh(high)))
		return 0;

	/*
	 * high
	 */
	 if (ISoddhigh(high) && ISupperhigh(high)) {
		high = (high - 0x21) / 2 + 0x81;
		o = 1;
	 }
	 if (ISevenhigh(high) && ISupperhigh(high)) {
		high = (high - 0x22) / 2 + 0x81;
		o = 0;
	 }
	 if (ISoddhigh(high) && ISlowerhigh(high)) {
		high = (high - 0x5f) / 2 + 0xe0;
		o = 1;
	 }
	 if (ISevenhigh(high) && ISlowerhigh(high)) {
		high = (high - 0x60) / 2 + 0xe0;
		o = 0;
	 }

	 /*
	  * low
	  */
	  if (o == 1) {
		/*	It's odd	*/
		low = low + 0x40 - 0x21;
	  } else {
		/*	It's even	*/
		low = low + 0x9e - 0x21;
	  }
	  if (low >= 0x7f)
		++low;
	  sJch = (high << 8) | low;
	  return(sJch);
}
