#ifndef lint
static char	rcsid[] = "$Header: wcreate.c,v 2.1 87/10/18 19:07:37 tachi Exp $" ;
#endif

#include "win.h"

Win *
w_create(lines, cols, y, x)
	int	lines ;
	int	cols ;
	int	y, x ;
{
	Win	*w ;
	register Wline	*p ;
	register Wchar	*bp ;
	register int	i ;

	if ( (w = (Win *) calloc(1, sizeof(Win))) == NULL )
		return	NULL ;
	if ( lines == 0 )
		lines = num_li - y ;
	if ( cols == 0 )
		cols = num_co - x ;
	w->w_lines = lines ;
	w->w_cols = cols ;
	w->w_start.y = y ;
	w->w_start.x = x ;
	if ( (w->w_l = (Wline *) calloc(lines, sizeof(Wline))) == NULL )
		return	NULL ;
	if ( (w->w_rawbuf = (Wchar *) malloc(cols * lines * sizeof(Wchar))) == NULL )
		return	NULL ;
/*
	for ( bp = w->w_rawbuf, i = (cols + 1) * lines ; i > 0 ; i-- )
		*bp++ = make_wchar(' ', 0) ;
*/
	for ( p = w->w_l, bp = w->w_rawbuf, i = lines ; i > 0 ; i--, p++ ) {
		p->l_buf = bp ;
		p->l_modflag = 0 ;
		bp += cols ;
	}
	w_attach_flags(w) ;
	w_clear(w) ;

	return	w ;
}

Win *
w_create_sub(pw, lines, cols, y, x)
	Win	*pw ;
	int	lines, cols, y, x ;
{
	Win	*w ;
	register Wline	*p, *q ;
	register int	i ;

	if ( (w = (Win *) calloc(1, sizeof(Win))) == NULL )
		return	NULL ;
	if ( lines <= 0 )
		lines += pw->w_lines - y ;
	if ( cols <= 0 )
		cols += pw->w_cols - x ;
	w->w_lines = lines ;
	w->w_cols = cols ;
	w->w_start.y = pw->w_start.y + y ;
	w->w_start.x = pw->w_start.x + x ;
	if ( (w->w_l = (Wline *) calloc(lines, sizeof(Wline))) == NULL )
		return	NULL ;
	for ( p = w->w_l, q = pw->w_l + y, i = lines ; i > 0 ; i--, p++, q++ ) {
		p->l_buf = q->l_buf + x ;
		p->l_modflag = q->l_modflag ;
	}
	w_attach_flags(w) ;

	return	w ;
}

static
w_attach_flags(w)
	Win	*w ;
{
	if ( w->w_start.x + w->w_cols >= num_co ) {
		if ( w->w_start.y + w->w_lines >= num_li ) {
			if ( w->w_start.x <= 0 ) {
				if ( w->w_start.y <= 0 )
					w->w_flags |= W_FULL ;
				w->w_flags |= W_BOTTOM ;
			}
		}
		w->w_flags |= W_RIGHT ;
	}
}

w_destroy(w)
	Win	*w ;
{
	if ( w->w_rawbuf )
		free(w->w_rawbuf) ;
	free(w->w_l) ;
	free(w) ;
}
