/* $Header: win.h,v 2.1 87/10/18 19:08:27 tachi Exp $ */
#include <stdio.h>
#include <sys/ioctl.h>

typedef unsigned char	uchar ;

typedef unsigned short	Wchar ;
#define 	A_BOLD		(0x1 << 8)
/*#define 	A_UNDER		(0x2 << 8)*/
#define 	A_REVERSE	(0x4 << 8)
#define 	A_BLINK		(0x8 << 8)
#define 	A_GRAPHIC	(0x10 << 8)
#define		A_KANJI		(0x20 << 8)
#define		A_KANJI2	(0x40 << 8)

#define	kanji_first(wc)		(((wc) & (A_KANJI | A_KANJI2)) == A_KANJI)
#define	kanji_second(wc)	((wc) & A_KANJI2)

#define make_wchar(ch, attr)	((Wchar) ((attr) | (ch)))
#define wc_eql(wc1, wc2)	((wc1) == (wc2))
#define wc_attr(wc)	\
	((wc) & (A_BOLD | A_REVERSE | A_BLINK | A_GRAPHIC | A_KANJI))
#define wc_char(wc)		((wc) & 0x00ff)

typedef struct pos {
	int	y, x ;
} Pos ;

typedef struct {
	char	l_modflag ;
	Wchar	*l_buf ;
} Wline ;

typedef struct {
	Wline	*w_l ;
	Wchar	*w_rawbuf ;
	Pos	w_pos ;		/* current position */
	int	w_lines ;	/* number of lines */
	int	w_cols ;	/* number of columns */
	Pos	w_start ;	/* the position of left upper corner */
	int	w_flags ;
			/* attributes */
#define			W_FULL		0x1
#define			W_BOTTOM	0x2
#define			W_RIGHT		0x4
			/* dynamic flags */
#define			W_CLEAR		0x8
} Win ;

Win	*_screen ;	/* cached window */

char	*str_as, *str_ae, *str_ce, *str_cd, *str_cl, *str_cm ;
char	*str_cr, *str_nl, *str_up, *str_do ;
char	*str_nd, *str_le ;
int	num_co, num_li ;
char	*str_mr, *str_md, *str_mb, *str_me ;
char	*str_ti, *str_te ;
char	*str_bl, *str_vb ;
char	*str_ji, *str_jo ;	/* kanji in/out: not termcap entry */

extern int	w_outc() ;
#define Tputs(str)	if (str) tputs(str, 0, w_outc)

extern Win	*w_create() ;
extern Win	*w_create_sub() ;

#define w_getch(w, y, x)	(*((w)->w_l[y].l_buf + (x)))
#define w_redraw(w)		w_redraw_it(w, 1)
#define w_update(w)		w_redraw_it(w, 0)

struct sgttyb	sgttyb ;

/* user options */

int	kanji_code ;		/* should be set by reading TERMCAP or ioctl,
				   but there's no such capabilities in
				   standard unix */
#define		K_EUC	0
#define		K_JIS	1
#define		K_SJIS	2

int	reset_attr_after_redraw ;/* reset character attributes of the terminal
				   after displaying some characters with
				   attributes. */
