#ifndef lint
static char	rcsid[] = "$Header: winit.c,v 2.1 87/10/18 19:10:10 tachi Exp $" ;
#endif

#include "win.h"

static char	termarea[1024] ;

extern char	*getenv(), *tgetstr() ;
extern int	w_outc() ;

w_init()
{
	char	*term ;
	char	*ap = termarea ;
	char	termbuf[1024] ;

	if ( (term = getenv("TERM")) == NULL ) {
		fprintf(stderr, "Could not get TERM environment variable!\n") ;
		return	-1 ;
	}
	if ( tgetent(termbuf, term) <= 0 ) {
		fprintf(stderr, "Could net get termcap entry for %s", term) ;
		return	-1 ;
	}
	if ( (str_as = tgetstr("as", &ap)) != NULL) {	/* start alternate character set */
		if ( strncmp(str_as, "\033(0", 3) != 0 )
			str_as = NULL ;
	}
	str_ae = tgetstr("ae", &ap) ;	/* end alternate character set */
	str_ce = tgetstr("ce", &ap) ;	/* clear to end of line */
	str_cd = tgetstr("cd", &ap) ;	/* clear to end of display */
	str_cl = tgetstr("cl", &ap) ;	/* clear screen and home cursor */
	if ( (str_cm = tgetstr("cm", &ap)) == NULL ) {	/* screen relative cursor motion */
		fprintf(stderr, "No escape sequence for cursor motion?!\n") ;
		return	-1 ;
	}
	if ( (str_cr = tgetstr("cr", &ap)) == NULL )	/* carriage return */
		str_cr = "\r" ;
	if ( (str_nl = tgetstr("nl", &ap)) == NULL )	/* new line */
		str_nl = "\n" ;
#ifdef notdef
	str_up = tgetstr("up", &ap) ;	/* cursor up */
	if ( (str_do = tgetstr("do", &ap)) == NULL )	/* cursor down */
		str_do = "\n" ;
	str_nd = tgetstr("nd", &ap) ;	/* non-destructive space */
	if ( (str_le = tgetstr("le", &ap)) == NULL )	/* cursor left */
		str_le = "\b" ;
#endif notdef
	num_co = tgetnum("co") ;	/* number of columns */
	num_li = tgetnum("li") ;	/* number of lines */
	if ( (str_mr = tgetstr("mr", &ap)) == NULL )	/* turn on reverse attribute */
		str_mr = tgetstr("so", &ap) ;
	if ( (str_md = tgetstr("md", &ap)) == NULL )	/* turn on bold attribute */
		str_md = str_mr ;
	if ( (str_mb = tgetstr("mb", &ap)) == NULL )	/* turn on blinking attribute */
		str_mb = str_md ;
	if ( (str_me = tgetstr("me", &ap)) == NULL )	/* turn off all attributes */
		str_me = tgetstr("se", &ap) ;
	str_ti = tgetstr("ti", &ap) ;	/* string to begin program using cm */
	str_te = tgetstr("te", &ap) ;	/* string to end program using cm */
	str_vb = tgetstr("vb", &ap) ;	/* visible bell */
	str_bl = tgetstr("bl", &ap) ;	/* audible bell */
	str_ji = "\033$@" ;	/* shift to (old) jis kanji code */
	str_jo = "\033(J" ;	/* shift to jis roman */

	if ( (_screen = w_create(0, 0, 0, 0)) == NULL )
		return	-1 ;
	w_init_screen() ;
	_screen->w_flags &= ~W_CLEAR ;	/* kludge */

	return	0 ;
}

w_end()
{
	w_end_screen() ;
	if ( _screen != NULL )
		w_destroy(_screen) ;
	_screen = NULL ;
}

w_init_screen()
{
	w_set_tty() ;

	if ( str_ti )
		tputs(str_ti, 0, w_outc) ;
	w_redraw_screen() ;
}

w_end_screen()
{
	w_set_attr(0) ;
	tputs(tgoto(str_cm, 0, _screen->w_lines - 1), 0, w_outc) ;
	tputs(str_nl, 1, w_outc) ;
	if ( str_te )
		tputs(str_te, 0, w_outc) ;
	fflush(stdout) ;

	w_reset_tty() ;
}

w_set_tty()
{
	ioctl(0, TIOCGETP, &sgttyb) ;
	sgttyb.sg_flags |= CBREAK ;
	sgttyb.sg_flags &= ~(ECHO | CRMOD);
	ioctl(0, TIOCSETP, &sgttyb) ;
}

w_reset_tty()
{
	sgttyb.sg_flags &= ~CBREAK ;
	sgttyb.sg_flags |= (ECHO | CRMOD) ;
	ioctl(0, TIOCSETP, &sgttyb) ;
}
