#ifndef lint
static char	rcsid[] = "$Header: woutput.c,v 2.2 87/10/25 18:04:57 tachi Exp $" ;
#endif

#include "win.h"

static Wchar	lastattr = 0 ;

w_output(y, x, p, q, lead, clear)
	int	y, x ;
	register Wchar	*p, *q ;
	Wchar	*lead ;
	int	clear ;
{
	char	*cmstr ;
	char	*tgoto() ;
	int	x0 ;

	x0 = x - (q - p) ;
	if ( kanji_second(*p) && x0 > 0 )
		--p, --x0 ;
	if ( kanji_second(*q) && x < _screen->w_lines - 1 )
		++q, ++x ;
	if ( !(y == _screen->w_pos.y && x0 == _screen->w_pos.x) ) {
		if ( (lastattr & A_KANJI) && kanji_code == K_JIS ) {
			lead = NULL ;
			w_set_attr(lastattr & ~A_KANJI) ;
		}
		cmstr = tgoto(str_cm, x0, y) ;
		if ( lead != NULL ) {
			if ( strlen(cmstr) < p - lead )
				lead = NULL ;
			else if ( wc_attr(*lead) != lastattr ) {
				if ( wc_attr(*lead) == wc_attr(*p) )
					w_set_attr(wc_attr(*p)) ;
				else if ( !clear || (lastattr & A_REVERSE) )
					lead = NULL ;
			}
		}
		if ( lead != NULL ) {
			while ( lead < p ) {
				putchar(wc_char(*lead)) ;
				++lead ;
			}
		} else {
			tputs(cmstr, 0, w_outc) ;
		}
	}

	w_set_attr(wc_attr(*p)) ;

	if ( wc_attr(*p) & A_KANJI ) {
		switch ( kanji_code ) {
		case  K_JIS :
			while ( p < q ) {
				putchar(wc_char(*p) & 0177) ;
				++p ;
			}
			break ;
		case  K_SJIS :
			while ( p < q ) {
				int	c ;
				c = wc_char(*p) << 8 ;
				c += wc_char(*++p) ;
				c = toSJIS(c) ;
				putchar(c >> 8) ;
				putchar(c & 0xff) ;
				++p ;
			}
			break ;
		case  K_EUC :
			goto  normal ;
		}
	} else {
	normal :
		while ( p < q ) {
			putchar(wc_char(*p)) ;
			++p ;
		}
	}
	_screen->w_pos.y = y ;
	_screen->w_pos.x = x ;
}

w_outc(ch)
{
	putchar(ch) ;
}

w_set_attr(attr)
	Wchar	attr ;
{
	register Wchar	diff, a ;

	if ( !(diff = lastattr ^ attr) )
		return ;

	if ( (a = diff & lastattr) ) {
		/* some attributes are off */
		if ( (a & A_GRAPHIC) )
			Tputs(str_ae) ;
		if ( a & (A_BOLD | A_REVERSE | A_BLINK) ) {
			Tputs(str_me) ;
			diff |= attr & (A_BOLD | A_REVERSE | A_BLINK) ;
		}
		if ( kanji_code == K_JIS && (a & A_KANJI) ) {
			Tputs(str_jo) ;
		}
	}
	if ( (a = diff & attr) ) {
		/* some attributes are on */
		if ( a & A_GRAPHIC )
			Tputs(str_as) ;
		if ( a & A_BLINK )
			Tputs(str_mb) ;
		if ( a & A_BOLD )
			Tputs(str_md) ;
		if ( a & A_REVERSE )
			Tputs(str_mr) ;
		if ( kanji_code == K_JIS && (a & A_KANJI) )
			Tputs(str_ji) ;
	}
	lastattr = attr ;
}

w_move_cursor(y, x)
	int	y, x ;
{
	if ( y == _screen->w_pos.y && x == _screen->w_pos.x )
		return ;
	tputs(tgoto(str_cm, x, y), 0, w_outc) ;
	_screen->w_pos.y = y ;
	_screen->w_pos.x = x ;
}
