#include "win.h"

w_setpos(w, y, x)
	Win	*w ;
	int	y, x ;
{
	if ( y < 0 )
		y += w->w_lines ;
	if ( x < 0 )
		x += w->w_cols ;
	w->w_pos.y = y ;
	w->w_pos.x = x ;
}

static
w_putgeneric(w, str, len, attr, mapfunc)
	register Win	*w ;
	uchar	*str ;
	int	len ;
	Wchar	attr ;
	register Wchar	(*mapfunc)() ;
{
	register int	x, y ;
	register Wchar	*bp ;
	register int	kanji = 0 ;
	Wchar	a ;

	y = w->w_pos.y ;
	x = w->w_pos.x ;
	for ( ; y < w->w_lines ; y++, x = 0 ) {
		w->w_l[y].l_modflag = 1 ;
		bp = w->w_l[y].l_buf + x ;
		for ( ; x < w->w_cols ; x++ ) {
			if ( len-- <= 0 )
				goto  end ;
			a = attr ;
			if ( kanji ) {
				/* second byte */
				if ( x < w->w_cols - 1 && kanji_second(*(bp + 1)) )
					*(bp + 1) = make_wchar(' ', 0) ;
				a |= A_KANJI | A_KANJI2 ;
				kanji = 0 ;
			} else if ( *str & 0x80 ) {
				/* first byte */
				if ( x == w->w_cols - 1 ) {
					/* goto next line and retry */
					*bp = make_wchar(' ', 0) ;
					len++ ;
					continue ;
				}
				if ( x > 0 && kanji_first(*(bp - 1)) )
					*(bp - 1) = make_wchar(' ', 0) ;
				a |= A_KANJI ;
				kanji = 1 ;
			}
			*bp++ = (*mapfunc)(*str++, a) ;
		}
	}
end :
	w->w_pos.x = x ;
	w->w_pos.y = y ;

	w->w_flags &= ~W_CLEAR ;
}

static
Wchar
w_normal_map(ch, attr)
	Wchar	ch ;
	Wchar	attr ;
{
	Wchar	c = ch & 0x7f ;

	if ( (c >= 0x20 && c < 0x7f) )
		/* printable ascii character */
		return	make_wchar(ch, attr) ;
	else
		return	make_wchar(' ', 0) ;
}

w_vputstr(w, str, len, attr)
	Win	*w ;
	uchar	*str ;
	int	len ;
	Wchar	attr ;
{
	w_putgeneric(w, str, len, attr, w_normal_map) ;
}

w_putstr(w, str, attr)
	Win	*w ;
	uchar	*str ;
	Wchar	attr ;
{
	w_putgeneric(w, str, strlen(str), attr, w_normal_map) ;
}

static Wchar	def_stems[] = {
	make_wchar(' ', 0), make_wchar(' ', 0),
	make_wchar(' ', 0), make_wchar('-', 0),
	make_wchar(' ', 0), make_wchar('-', 0),
	make_wchar('-', 0), make_wchar('-', 0),
	make_wchar(' ', 0), make_wchar('-', 0),
	make_wchar('|', 0), make_wchar('|', 0),
	make_wchar('-', 0), make_wchar('-', 0),
	make_wchar('|', 0), make_wchar('+', 0),
} ;

static Wchar	ansi_stems[] = {
	make_wchar(' ', 0), make_wchar(' ', 0),
	make_wchar(' ', 0), make_wchar('m', A_GRAPHIC),
	make_wchar(' ', 0), make_wchar('q', A_GRAPHIC),
	make_wchar('j', A_GRAPHIC), make_wchar('v', A_GRAPHIC),
	make_wchar(' ', 0), make_wchar('l', A_GRAPHIC),
	make_wchar('x', A_GRAPHIC), make_wchar('t', A_GRAPHIC),
	make_wchar('k', A_GRAPHIC), make_wchar('w', A_GRAPHIC),
	make_wchar('u', A_GRAPHIC), make_wchar('n', A_GRAPHIC),
} ;

static
Wchar
w_graphic_map(ch, attr)
	Wchar	ch, attr ;
{
	return	str_as? make_wchar(ansi_stems[ch], attr) :
			make_wchar(def_stems[ch], attr) ;
}

w_vputgstr(w, str, len, attr)
	Win	*w ;
	uchar	*str ;
	int	len ;
	Wchar	attr ;
{
	w_putgeneric(w, str, len, attr, w_graphic_map) ;
}

w_putgstr(w, str, attr)
	Win	*w ;
	uchar	*str ;
	Wchar	attr ;
{
	w_putgeneric(w, str, strlen(str), attr, w_graphic_map) ;
}

w_deletech(w)
	register Win	*w ;
{
	static Wchar	blank = make_wchar(' ', 0) ;

	if ( w->w_pos.x == 0 ) {
		if ( w->w_pos.y == 0 )
			return ;
		--w->w_pos.y ;
		w->w_pos.x = w->w_cols - 1 ;
		w_putgeneric(w, &blank, 1, 0, w_normal_map) ;
		--w->w_pos.y ;
		w->w_pos.x = w->w_cols - 1 ;
	} else {
		--w->w_pos.x ;
		w_putgeneric(w, &blank, 1, 0, w_normal_map) ;
		--w->w_pos.x ;
	}
}
