#ifndef lint
static char	rcsid[] = "$Header: wredraw.c,v 2.1 87/10/18 19:13:58 tachi Exp $" ;
#endif

#include "win.h"

w_redraw_it(w, force)
	Win	*w ;
	int	force ;
{
	register Wchar	*sp ;	/* pointer to screen buffer */
	register Wchar	*bp ;	/* current pointer to window buffer */
	register Wchar	*dp ;	/* beginning of buffer to output */
	register Wchar	*ep ;	/* possibly end of buffer at the last output ;
				   control cursor motion in w_output */
	Wline	*spp, *bpp ;
	register int	x, y ;
	int	clear ;
	int	maxy, minx, maxx ;
	register int	screen = (w == _screen) ;
	int	doout ;

/*
printf("w_redraw: w = %x, start = (%d, %d), %d lines, %d cols\n",
		w, w->w_start.y, w->w_start.x, w->w_lines, w->w_cols) ;
*/

	if ( (maxy = w->w_start.y + w->w_lines) > _screen->w_lines )
		maxy = _screen->w_lines ;
	if ( (y = w->w_start.y) < 0 )
		y = 0 ;
	if ( (maxx = w->w_start.x + w->w_cols) > _screen->w_cols )
		maxx = _screen->w_cols ;
	if ( (minx = w->w_start.x) < 0 )
		minx = 0 ;

	if ( force && w->w_flags & W_CLEAR ) {
		if ( w_output_clear(w, y, maxy, minx) )
			/* use normal redrawing strategy */
			doout = 1 ;
		else
			doout = 0 ;
	} else
		doout = 1 ;

	spp = _screen->w_l + y ;
	bpp = w->w_l + y - w->w_start.y ;
	for ( ; y < maxy ; y++, spp++, bpp++ ) {
		if ( !force && bpp->l_modflag == 0 )
			continue ;
		sp = spp->l_buf + minx ;
		bp = bpp->l_buf + minx - w->w_start.x ;
		dp = NULL ;
		ep = NULL ;
		clear = 0 ;
		for ( x = minx ; x < maxx ; x++, sp++, bp++ ) {
			if ( screen && *sp == make_wchar(' ', 0) ||
			     !screen && wc_eql(*sp, *bp) )
			{
				if ( dp != NULL ) {
					w_output(y, x, dp, bp, ep, clear) ;
					dp = NULL ;
					ep = bp ;
					clear = 1 ;
				}
				if ( ep != NULL ) {
					if ( wc_attr(*ep) != wc_attr(*bp) )
						ep = NULL ;
					if ( *bp != make_wchar(' ', 0) )
						clear = 0 ;
				}
			} else {
				if ( doout ) {
					if ( dp == NULL ) {
						/* mark the start position */
						dp = bp ;
					}
					else if ( wc_attr(*dp) != wc_attr(*bp) ) {
						w_output(y, x, dp, bp, ep, clear) ;
						dp = bp ;
						ep = NULL ;
						clear = 0 ;
					}
				}
				*sp = *bp ;
			}
		}
		if ( dp != NULL ) {
			w_output(y, x, dp, bp, ep, clear) ;
		}
		bpp->l_modflag = 0 ;
	}

	if ( reset_attr_after_redraw )
		w_set_attr(0) ;

	w_redraw_cursor(w) ;
}

w_redraw_cursor(w)
	Win	*w ;
{
	w_move_cursor(w->w_pos.y + w->w_start.y, w->w_pos.x + w->w_start.x) ;
	fflush(stdout) ;
}

w_redraw_screen()
{
	Pos	pos ;

	w_output_clear(_screen, 0, _screen->w_lines, 0) ;
	/* w_output will overrides _screen->w_pos, so temporarily save it */
	pos = _screen->w_pos ;
	w_redraw(_screen) ;
	w_move_cursor(pos.y, pos.x) ;
	fflush(stdout) ;
}
